﻿:: LFE (Leafy - Local File Encryption), a tool to encrypt and store local files.
:: Copyright (C) 2006 Opendawn.com
:: Release 1
:: This version is for Mobility Email (http://www.mobilityemail.net/)
::
:: This program is free software; you can redistribute it and/or modify
:: it under the terms of the GNU General Public License as published by
:: the Free Software Foundation; either version 2 of the License, or
:: (at your option) any later version.
::
:: This program is distributed in the hope that it will be useful,
:: but WITHOUT ANY WARRANTY; without even the implied warranty of
:: MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
:: GNU General Public License for more details.
::
:: You should have received a copy of the GNU General Public License
:: along with this program; if not, write to the Free Software
:: Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA




:: ===== START =====
:: This is the section of the code to start the process.
:START

:: Turns off command output to the screen and clears existing output
@ECHO OFF
CLS

:: This is the section of the code that names the process.
TITLE Mobility Email - Profile encryption tool

:: Sets the foreground and background color.
COLOR f0

:: Clears screen output.
CLS

:: Changes into the Programs directory.
CD Programs

IF EXIST=LFELOCK.GPG GOTO UNLOCK ELSE GOTO LOCK
:: ===== END START =====

:: ===== LOCK =====
:: This is the section of the code to lock a profile folder.
:LOCK

:: Welcome text displayed to the user
ECHO This is a tool to lock and unlock your profile.
ECHO Copyright (c) 2006 Opendawn.com
ECHO This tool is released under the GNU GPL license.
ECHO.
ECHO Mobility Email will now lock your profile.
ECHO.
ECHO Please press any key to continue.
ECHO If you don't want to do this, press CTRL-C.
PAUSE>NUL

:: Clears screen output
CLS

:: Zips the profile folder into LFELOCK.ZIP
zip -qr LFELOCK.zip ..\Profile

:: Clears screen output
CLS

ECHO Please enter a password to lock your profile.
ECHO.

:: Calls GPG to encrypt the LFELOCK.ZIP file with AES256
gpg --output LFELOCK.gpg --quiet --symmetric --compress-algo none --cipher-algo aes256 LFELOCK.zip

:: Clears screen output
CLS

IF EXIST=LFELOCK.GPG GOTO WASH ELSE GOTO RELOCK
:: ===== END LOCK =====



:: ===== RELOCK =====
:: This is the section of the code to relock the compressed profile archive.
:RELOCK
ECHO You mistyped your password.  We have to start again.
ECHO.

:: Unzips the LFELOCK.ZIP file to the normal application root directory
UNZIP -qo LFELOCK.zip -d ..\

eraserd -file LFELOCK.zip -silent

:: Clears screen output
CLS

GOTO LOCK
:: ===== END RELOCK =====


:: ===== UNLOCK =====
:: This is the section of the code to lock a profile folder.
:UNLOCK

:: Welcome text displayed to the user
ECHO This is a tool to lock and unlock your profile.
ECHO Copyright (c) 2006 Opendawn.com
ECHO This tool is released under the GNU GPL license.
ECHO.
ECHO Mobility Email will now unlock your profile.
ECHO.
ECHO Please press any key to continue.
ECHO If you don't want to do this, press CTRL-C.
PAUSE>NUL

:: Clears screen output
CLS

ECHO Please enter your password to unlock your profile.
ECHO.

:: Calls GPG to decrypt the LFELOCK.GPG file
gpg --output LFELOCK.zip --decrypt LFELOCK.gpg

IF EXIST=LFELOCK.ZIP GOTO CLEANUP ELSE GOTO SECONDTRY
:: ===== END UNLOCK =====



:: ===== SECONDTRY =====
:: This is the section of the code to reunlock the encrypted profile archive.
:SECONDTRY
ECHO You mistyped your password.  Please enter it again.
ECHO.
gpg --output LFELOCK.zip --decrypt LFELOCK.gpg
:: ===== END SECONDTRY =====


:: ===== WASH =====
:: This is the section of the code to erase the original profile files.
:WASH

:: Erases the unencrypted LFELOCK.ZIP file
eraserd -file LFELOCK.zip -silent

:: Clears screen output
CLS

:: Erases the original profile folder and subfolders
eraserd -folder ..\Profile -subfolders -silent

:: Clears screen output
CLS

ECHO Your profile is now locked.
ECHO (An encrypted archive called LFELOCK.GPG is stored in the PROGRAMS directory.)
ECHO.
ECHO Press any key to continue.
PAUSE>NUL
GOTO QUIT
:: ===== END WASH =====


:: ===== CLEANUP =====
:: This is the section of the code to reunlock the encrypted profile archive.
:CLEANUP

:: Deletes the LFELOCK.GPG file.
:: This file is not erased as it is already encrypted, and we want to
:: speed up the unlocking process.
DEL LFELOCK.gpg

:: Clears screen output
CLS

:: Unzips the LFELOCK.ZIP file to the normal application root directory
UNZIP -q LFELOCK.zip -d ..\

:: Erases the LFELOCK.ZIP file
eraserd -file LFELOCK.zip -silent

:: Clears screen output
CLS

ECHO Your profile is now unlocked.
ECHO.
ECHO Press any key to continue.
PAUSE>NUL

GOTO QUIT
:: ===== END CLEANUP =====



:: ===== QUIT =====
:: This is the section of the code to end the process.
:QUIT
:: Changes to the normal application root directory
CD..
: ===== END QUIT =====